package cn.timer.api.controller.zpgl.sevice;

import cn.timer.api.bean.clazz.SysRegion;
import cn.timer.api.bean.yggl.YgglMainEmp;
import cn.timer.api.bean.zpgl.ZpglFail;
import cn.timer.api.bean.zpgl.ZpglMslcLog;
import cn.timer.api.bean.zpgl.ZpglRcxx;
import cn.timer.api.config.annotation.UserBean;
import cn.timer.api.config.enuminterface.JxglEnumInterface;
import cn.timer.api.config.exception.CustomException;
import cn.timer.api.controller.kqgl.ClockInTool;
import cn.timer.api.dto.baidu.BaiduTicResumeDto;
import cn.timer.api.dto.baidu.ResumeExtract;
import cn.timer.api.bean.clazz.NationClass;
import cn.timer.api.dto.zpgl.ImportCandidateDto;
import cn.timer.api.dto.zpgl.ZpglRcxxDto;
import cn.timer.api.utils.ZpglMessageTemplate;
import cn.timer.api.utils.baidu.BaiduTicUtil;
import cn.timer.api.utils.baidu.Base64;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import org.springframework.web.multipart.MultipartFile;

import javax.transaction.Transactional;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author wuqingjun
 * @email 284718418@qq.com
 * @date 2022/3/18
 */
@Slf4j
@Service
@Transactional(rollbackOn = Exception.class)
public class ZpglServiceImpl implements ZpglService {

    @Autowired
    private BaiduTicUtil baiduTicUtil;

    @Autowired
    private ZpglMslcLogService zpglMslcLogService;


    @Override
    public boolean updateZpglRcxx(UserBean userBean, ZpglRcxxDto zpglRcxxDto) {
        boolean count = false;
        ZpglRcxx zpglRcxx = ZpglRcxx.builder().id(zpglRcxxDto.getId()).status(zpglRcxxDto.getStatus()).build();
        ZpglMslcLog zpglMslcLog = new ZpglMslcLog();
        zpglMslcLog.setZpglRcxxId(zpglRcxxDto.getId());
        zpglMslcLog.setUserId(userBean.getEmpNum());
        zpglMslcLog.setUserName(userBean.getQyzxEmpLogin().getUsername());
        if(!StringUtils.isEmpty(zpglRcxxDto.getIfrck()) && zpglRcxxDto.getIfrck().intValue() == 1){
            zpglRcxx.setIfrckTime(new Date());
        }
        String detail = "";
        switch (zpglRcxxDto.getStatus()) {
            case 1:
                //待初筛 填充字段
                detail = ZpglMessageTemplate.print(ZpglMessageTemplate.FILTERING, new String[]{
                        userBean.getQyzxEmpLogin().getUsername()});
                break;
            case 2:
                //初筛通过 填充字段
                zpglRcxx.setIfrck(zpglRcxxDto.getIfrck());
                detail = ZpglMessageTemplate.print(ZpglMessageTemplate.FILTER_PASS, new String[]{
                        userBean.getQyzxEmpLogin().getUsername()});
                break;
            case 3:
                //安排面试 填充字段
                zpglRcxx.setInterviewNum(zpglRcxxDto.getInterviewNum());
                zpglRcxx.setInterviewWay(zpglRcxxDto.getInterviewWay());
                zpglRcxx.setInterviewerId(zpglRcxxDto.getInterviewerId());
                zpglRcxx.setInterviewTime(zpglRcxxDto.getInterviewTime());
                zpglRcxx.setNoticeWay(zpglRcxxDto.getNoticeWay());
                YgglMainEmp ygglMainEmp = YgglMainEmp.builder().build().selectOne(new QueryWrapper<YgglMainEmp>().select("name").lambda().eq(YgglMainEmp::getEmpNum, zpglRcxxDto.getInterviewerId()));
                detail = ZpglMessageTemplate.print(ZpglMessageTemplate.INTERVIEW, new String[]{
                        userBean.getQyzxEmpLogin().getUsername(),
                        zpglRcxxDto.getInterviewNum().toString(),
                        new SimpleDateFormat("yyyy-MM-dd' 'HH:mm:ss").format(zpglRcxxDto.getInterviewTime()),
                        ygglMainEmp.getName()});
                break;
            case 4:
                detail = ZpglMessageTemplate.print(ZpglMessageTemplate.INTERVIEWED, new String[]{
                        userBean.getQyzxEmpLogin().getUsername(), zpglRcxxDto.getInterviewNum().toString()});
                break;
            case 5:
                detail = ZpglMessageTemplate.print(ZpglMessageTemplate.INTERVIEW_PASS, new String[]{
                        userBean.getQyzxEmpLogin().getUsername()});
                break;
            case 6:

                detail = ZpglMessageTemplate.print(ZpglMessageTemplate.EMPLOY, new String[]{
                        userBean.getQyzxEmpLogin().getUsername()});
                break;
            case 7:
                //发送offer 填充字段
                zpglRcxx.setBmgwId(zpglRcxxDto.getBmgwId());
                zpglRcxx.setJobType(zpglRcxxDto.getJobType());
                zpglRcxx.setYjrzTime(zpglRcxxDto.getYjrzTime());
                detail = ZpglMessageTemplate.print(ZpglMessageTemplate.OFFER, new String[]{
                        userBean.getQyzxEmpLogin().getUsername()});
                //发送offer
                break;
            case 8:
                //待入职 填充字段
                zpglRcxx.setBmgwId(zpglRcxxDto.getBmgwId());
                zpglRcxx.setJobType(zpglRcxxDto.getJobType());
                zpglRcxx.setYjrzTime(zpglRcxxDto.getYjrzTime());
                detail = ZpglMessageTemplate.print(ZpglMessageTemplate.WAIT, new String[]{
                        userBean.getQyzxEmpLogin().getUsername()});
                break;
            case 9:
                //淘汰 填充字段
                zpglRcxx.setZpglFailId(zpglRcxxDto.getZpglFailId());
                zpglRcxx.setRemarks(zpglRcxxDto.getRemarks());
                ZpglFail zpglFail = ZpglFail.builder().id(zpglRcxxDto.getZpglFailId()).build().selectById();
                String messageTemplate = ZpglMessageTemplate.ENTRYING;
                if (!StringUtils.isEmpty(zpglFail)) {
                    if (zpglFail.getZpglRcxxStatus().equals(JxglEnumInterface.ResumeStatus.INTERVIEW_PASS.getType())) {
                        messageTemplate = ZpglMessageTemplate.INTERVIEWED_ENTRYING;
                    }
                    if (zpglFail.getZpglRcxxStatus().equals(JxglEnumInterface.ResumeStatus.OFFER.getType())) {
                        messageTemplate = ZpglMessageTemplate.OFFER_ENTRYING;
                    }
                    detail = ZpglMessageTemplate.print(messageTemplate, new String[]{
                            userBean.getQyzxEmpLogin().getUsername(), zpglFail.getFailCause(), zpglRcxxDto.getRemarks()});
                }
                break;
            case 10:
                //确认入职
                detail = ZpglMessageTemplate.print(ZpglMessageTemplate.ENTRY, new String[]{
                        userBean.getQyzxEmpLogin().getUsername()});
                break;
            default:
                break;
        }
        zpglMslcLog.setDetail(detail);
        count = zpglRcxx.updateById();
        zpglMslcLogService.addZpglMslcLog(zpglMslcLog);
        return count;
    }

    @Override
    public SysRegion getSysRegion(Integer keyId) {
        return SysRegion.builder().build()
                .selectOne(new QueryWrapper<SysRegion>().lambda().eq(SysRegion::getKeyId, keyId).select(
                        SysRegion::getRegionName, SysRegion::getKeyId, SysRegion::getZipCode,
                        SysRegion::getRegionCode));
    }

    @Override
    public boolean addResumeImportCandidate(UserBean userBean, MultipartFile file, ImportCandidateDto importCandidateDto) {
        BaiduTicResumeDto baiduTicResumeDto = BaiduTicResumeDto.builder().filename(file.getOriginalFilename()).filetype(importCandidateDto.getSuffix()).filedata(Base64.getStrFromPath(file)).build();
        ResponseEntity<String> resumeString = baiduTicUtil.getResumeByCvParser(baiduTicResumeDto);
        JSONObject json = (JSONObject) JSONObject.parse(resumeString.getBody());
        log.info("招聘-导入候选人简历{}",resumeString.getBody());
        ResumeExtract resumeExtract = null;
        if("success".equals(json.get("error_msg"))){
            if(StringUtils.isEmpty(json.get("results"))){
                log.info("招聘-导入候选人简历:results is null");
                throw new CustomException("导入简历失败，请检查是否为简历文件~");
            }
            JSONArray array = (JSONArray)json.get("results");
            if(StringUtils.isEmpty(array.get(0))){
                log.info("招聘-导入候选人简历:results is null");
                throw new CustomException("导入简历失败，请检查是否为简历文件~");
            }
            JSONObject resultsJsonObject = (JSONObject) array.get(0);
            resumeExtract = JSONObject.toJavaObject((JSONObject)resultsJsonObject.get("extract"), ResumeExtract.class);
        }else {
            throw new CustomException("导入简历失败，请检查是否为简历文件~");
        }
        if(StringUtils.isEmpty(resumeExtract) || StringUtils.isEmpty(resumeExtract.getBasic_infos())){
            throw new CustomException("导入简历失败，请检查是否为简历文件~");
        }
        this.addZpglRcxx(userBean, resumeExtract, importCandidateDto);
        return true;
    }

    /**
     * 导入简历
     * 同步人才信息 教育资讯 基本信息 其他信息 项目信息 工作信息
     * @param resumeExtract
     * @param importCandidateDto
     */
    private void addZpglRcxx(UserBean userBean,ResumeExtract resumeExtract, ImportCandidateDto importCandidateDto){
        ZpglRcxx zpglRcxx = ZpglRcxx.builder().build();
        zpglRcxx.setZpglZwxxId(importCandidateDto.getZpglZwxxId());
        zpglRcxx.setStatus(importCandidateDto.getStatus());
        zpglRcxx.setZpglZpqdId(importCandidateDto.getZpglZpqdId());
        zpglRcxx.setOrgCode(userBean.getOrgCode().toString());
        if(!StringUtils.isEmpty(resumeExtract.getBasic_infos())){
            zpglRcxx.setName(resumeExtract.getBasic_infos().getName());
            zpglRcxx.setMobile(resumeExtract.getBasic_infos().getPhone_numbers());
            zpglRcxx.setMail(resumeExtract.getBasic_infos().getEmail_address());
            zpglRcxx.setWeixin(resumeExtract.getBasic_infos().getWechat());
            zpglRcxx.setIdCard(resumeExtract.getBasic_infos().getId_number());
            if(!StringUtils.isEmpty(resumeExtract.getBasic_infos().getGender())){
                zpglRcxx.setSex(resumeExtract.getBasic_infos().getGender().indexOf("男") != -1?0:1);
            }
            //出生日期，格式化为 年-月，如2000-01，若只有年，则只显示年，如2000
            if(!StringUtils.isEmpty(resumeExtract.getBasic_infos().getBirth_date())&&resumeExtract.getBasic_infos().getBirth_date().length() > 0){
                String datebirth = "";
                String[] num = resumeExtract.getBasic_infos().getBirth_date().split("-");
                if(num.length == 1){
                    datebirth = num[0]+"-1-1";
                }else if(num.length == 2){
                    datebirth = num[0]+"-"+num[1]+"-1";
                }
                if(datebirth.length()>0){
                    zpglRcxx.setDatebirth(ClockInTool.strToDateLong(datebirth));
                }
            }
            //nation_class_id
            if(!StringUtils.isEmpty(resumeExtract.getBasic_infos().getNation())){
                NationClass nationClass = NationClass.builder().build().selectOne(new QueryWrapper<NationClass>().lambda().like(NationClass::getName,resumeExtract.getBasic_infos().getNation()));
                if(!StringUtils.isEmpty(nationClass)){
                    zpglRcxx.setNationClassId(nationClass.getId());
                }
            }
            zpglRcxx.setAddress(resumeExtract.getBasic_infos().getHome_location());
            zpglRcxx.setUniversitie(resumeExtract.getBasic_infos().getSchool());
            if(!StringUtils.isEmpty(resumeExtract.getBasic_infos().getCur_duration())){
                zpglRcxx.setWorkyears(Integer.parseInt(resumeExtract.getBasic_infos().getCur_duration()));
            }
            zpglRcxx.setCompany(resumeExtract.getBasic_infos().getCur_company());
            zpglRcxx.insert();
        }
    }
}
